Option Explicit

' Declare all variables.
Dim objFSO,objFolder
Dim objInputFile
Dim objOutputFile
Dim strELM
Dim lngFileCount
Dim strFileName
Dim strFileLength
Dim strFileVersion
Dim strFileArray()
Dim X

' Create constants for the .elm version and Theme string.
Const strELMVersion  = "4.0.2.4022"
Const strThemeString = "<==MS-Theme==>"

' Create object for file I/O.
Set objFSO = WScript.CreateObject("Scripting.FileSystemObject")

' Get object for current folder.
Set objFolder = objFSO.GetFolder(".")

' Create variable for .elm file.
strELM = LCase(objFolder.Name & ".elm")

' Open the .elm file.
Set objInputFile = objFSO.OpenTextFile(strELM)

' Get the .elm file's version.
strFileVersion = objInputFile.ReadLine

' Get the file count.
lngFileCount = CLng(objInputFile.ReadLine)

' Create an array for file information.
ReDim strFileArray(lngFileCount)

' Create array from the file name/size list in the .elm file.
For X = 1 to lngFileCount
  strFileArray(X) = objInputFile.ReadLine
Next

' Loop through the array of files.
For X = 1 to lngFileCount
  ' Get the file name.
  strFileName = Left(strFileArray(X),InStrRev(strFileArray(X),",")-1)
  ' Get the file size.
  strFileLength = Mid(strFileArray(X),Len(strFileName) + 2)
  ' Create a file object for the output file.
  Set objOutputFile = objFSO.CreateTextFile(strFileName)
  ' Skip past the MS Theme text.
  objInputFile.Read Len(strThemeString)
  ' Extract the packed file data from the .elm file.
  objOutputFile.Write objInputFile.Read(strFileLength)
  ' Close the output file.
  objOutputFile.Close
Next

Set objFolder = Nothing
Set objFSO = Nothing